-- application
application:setBackgroundColor(0x196774)
local myappwidth = application:getContentWidth()
local myappheight = application:getContentHeight()

-- init
local player1imgs = {} -- table that will hold all the sprite sheet images
local player1anims = {} -- table that will hold all animations ("idle", "run", ...)
local player1currentanim = ""
local player1currentframe = 0
local player1animspeed = 1 / 30 -- change accordingly
local player1animtimer = player1animspeed

local hulkimgs = {} -- table that will hold all the sprite sheet images
local hulkanims = {} -- table that will hold all animations ("idle", "run", ...)
local hulkcurrentanim = ""
local hulkcurrentframe = 0
local hulkanimspeed = 1 / 2 -- change accordingly
local hulkanimtimer = hulkanimspeed

-- 1) cut spritesheets into images
function parseSpriteSheet(xcols, xrows, xspritesheettex, xspritesheetimgs)
	local spritesheettexregion = nil
	local w, h = xspritesheettex:getWidth() / xcols, xspritesheettex:getHeight() / xrows
	for r = 1, xrows do
		for c = 1, xcols do
			spritesheettexregion = TextureRegion.new(xspritesheettex, (c - 1) * w, (r - 1) * h, w, h)
			xspritesheetimgs[#xspritesheetimgs + 1] = spritesheettexregion
		end
	end
end
parseSpriteSheet(10, 3, Texture.new("playable/player1/Characters_1.png"), player1imgs)
parseSpriteSheet(4, 2, Texture.new("playable/hulk/hulk_face.png"), hulkimgs)

-- 2) create animations
function createAnim(xanims, xanimname, xspritesheetimgs, xstart, xfinish)
	xanims[xanimname] = {}
	for i = xstart, xfinish do
		xanims[xanimname][#xanims[xanimname] + 1] = xspritesheetimgs[i]
	end
end
createAnim(player1anims, "idle", player1imgs, 2, 2)
createAnim(player1anims, "walk", player1imgs, 1, 29)
createAnim(hulkanims, "idle", hulkimgs, 1, 8)

-- the game
local player1 = Bitmap.new(player1imgs[1])
player1:setAnchorPoint(0.5, 1)
player1:setAlpha(2)
player1:setScale(0.7)
player1currentanim = "idle"

local hulk = Bitmap.new(hulkimgs[1])
hulk:setAnchorPoint(0.5, 0.5)
hulk:setColorTransform(1, 2, 1, 1.2)
hulk:setScale(4)
hulkcurrentanim = "idle"

-- position
player1:setPosition(64, 2.5*myappheight/3)
hulk:setPosition(myappwidth/2, myappheight/4)
-- order
stage:addChild(hulk)
stage:addChild(player1)

-- moving the player
local isleft, isright = false, false
local player1x = player1:getX() -- for moving the player1
local player1sx = player1:getScaleX() -- for turning the player1
-- with the mouse
stage:addEventListener(Event.MOUSE_DOWN, function(e)
	if e.x < myappwidth / 2 then isleft = true
	else isright = true
	end
	player1currentanim = "walk"
end)
stage:addEventListener(Event.MOUSE_UP, function(e)
	isleft, isright = false, false
	player1currentanim = "idle"
end)
-- and/or the keyboard
stage:addEventListener(Event.KEY_DOWN, function(e)
	if e.keyCode == KeyCode.LEFT then isleft = true player1currentanim = "walk"
	elseif e.keyCode == KeyCode.RIGHT then isright = true player1currentanim = "walk"
	end
end)
stage:addEventListener(Event.KEY_UP, function(e)
	if e.keyCode == KeyCode.LEFT then isleft = false player1currentanim = "idle"
	elseif e.keyCode == KeyCode.RIGHT then isright = false player1currentanim = "idle"
	end
end)

-- the game loop
stage:addEventListener(Event.ENTER_FRAME, function(e)
	-- player1 anims
	player1animtimer = player1animtimer - e.deltaTime
	if player1animtimer <= 0 then
		player1currentframe += 1
		player1animtimer = player1animspeed
		if player1currentframe > #player1anims[player1currentanim] then
			player1currentframe = 1
		end
		player1:setTextureRegion(player1anims[player1currentanim][player1currentframe])
	end
	-- hulk anims
	hulkanimtimer = hulkanimtimer - e.deltaTime
	if hulkanimtimer <= 0 then
		hulkcurrentframe += 1
		hulkanimtimer = hulkanimspeed
		if hulkcurrentframe > #hulkanims[hulkcurrentanim] then
			hulkcurrentframe = 1
		end
		hulk:setTextureRegion(hulkanims[hulkcurrentanim][hulkcurrentframe])
	end
	-- player1 controls
	if isleft then
		player1x -= 64 * e.deltaTime
		if player1x < 0 then player1x = myappwidth end
		player1:setX(player1x)
		player1:setScale(-player1sx, player1:getScaleY())
	elseif isright then
		player1x += 64 * e.deltaTime
		if player1x > myappwidth then player1x = 0 end
		player1:setX(player1x)
		player1:setScale(player1sx, player1:getScaleY())
	end
end)
